%
% average a set of unrolledmaps, optionally using weighting maps
%

function [avemap,varmap] = averagemaps(select,maps,weights)

res = size(maps,1);
nmaps = size(maps,3);

avemap = zeros(res,res);
varmap = zeros(res,res);

if (nargin == 3)
  %% weighted mean and variance
  den = zeros(res,res);
  ct = 1;
  for j=1:length(select)
    avemap = avemap + maps(:,:,select(j)).*weights(:,:,select(j));
    den = den + weights(:,:,select(j));
    ct = ct + 1;
  end;
  den = den + (den==0);
  avemap = avemap./den;

  for j=1:length(select)
    varmap = varmap + ((maps(:,:,select(j)) - avemap).^2).*weights(:,:,select(j));
  end;
  varmap = varmap./den;
else
  %% mean and variance
  avemap2 = zeros(res,res);
  ct = 1;
  for j=1:length(select)
    avemap = avemap + maps(:,:,select(j));
    avemap2 = avemap2 + maps(:,:,select(j)).^2;
    ct = ct + 1;
  end;
  avemap = avemap./ct;
  avemap2 = avemap2./ct;
  varmap = avemap2 - avemap.^2;
end;
 
