%
% these are useful enumerations of different types that
% appear in the atlas construction process.  this is not
% a function since we want all the variables defined here
% to be included in whichever environ this script is executed.
%
% charless fowlkes (c) 2007
%

% versioning for this file
%constants_version = 'Thu Jan 31 11:44:16 PST 2008';
%constants_version = 'Thu Mar  3 16:31:29 PST 2011';  %added Alexa546 to dyelist
constants_version = 'Fri Jan 25 16:05:36 PST 2013'; %added BCD RNAI genotype

% cohorts
[cohort,cohort_names] = getcohorts();
%exclude "undefined" since it isn't really a cohort in this context
numcohorts = length(cohort_names)-1; 
cohort_names = cohort_names(1:numcohorts);
cohort_times = [40 50 60 70 80 90 100 110 120 130]; %best estimate of the cohort bin center in minutes

% genotypes...simplified genotype descriptor
genotype_names = { 'D. melanogaster', 'D. virilis', 'D. simulans', 'D. yakuba', 'D. erecta', 'D. ananassae', 'D. pseudoobscura', 'D. mojavensis','D. mel BCD RNAi','D. mel BCD RNAi2'};
genotype_enums = {'MEL','VIR','SIM','YAK','ERE','ANA','PSE','MOJ','MELBCD','MELBCD2'};
numgenotypes = length(genotype_names);
for i = 1:numgenotypes
  eval(sprintf('%s=%d;',genotype_enums{i},i));
end

dye_names = {'Cy3','Coumarin','Sytox Green','Alexa546','Alexa-488','Alexa555','Alexa610','Alexa633'};

% channel types, TODO: add density here
channeltype_names = {'mRNA','protein'};
channeltype_enums = {'MRNA','PROTEIN'};
numchanneltypes = length(channeltype_names);
for i = 1:numchanneltypes
  eval(sprintf('%s=%d;',channeltype_enums{i},i));
end

%
% genes : since this changes from one atlas to the next, we store 
%   it in the atlas creation directory rather than statically 
%   defining it here.
%
%  see collect_metadata.m
%

