
%
% render a nice looking density map
%
% dmap - the density image
% titlestr - title string for the figure
% llimit,ulimit - range of densities for color axis
%
% charless fowlkes, (c) 2007
%

function figure_density(dmap,titlestr,llimit,ulimit) 

  if (nargin<3)
    llimit = 0.025; ulimit = 0.050;
  end;
  contours = linspace(llimit,ulimit,35);
  imagesc(dmap); hold on;
  [c,h] = contour(dmap,contours,'k');
  for i = 1:length(h)
    set(h,'LineWidth',0.25)
  end;
  axis image; caxis([llimit ulimit]); colormap(jet(128));
  embryocoords(size(dmap,1),size(dmap,2),titlestr);
  hold off;
  colorbar;
