%
% compute normal direction based on nbr lists
% assumes the correct consistent ordering of the 
% nbrs generated by face2nbr
%
% charless fowlkes, (c) 2005-2007
%

function N = normals(V,nbrs,nnbrs);

 N = zeros(size(V));
 for i=1:length(V)
   if (nnbrs(i)>0)
     nlist =nbrs(i,1:nnbrs(i));
     %% coordinates of neighbors relative to nucleus in question
     relcoords = V(nlist,:)-repmat(mean(V(nlist,:)),nnbrs(i),1);

     %fit a plane to the neighborlist
     [U,S,Z] = svd(cov(relcoords));
     N(i,:) = U(:,3)';
   else
     fprintf('hmmm, no neighbors\n');
   end;
 end;
 N = N ./ repmat(sum(N.^2,2).^0.5,1,3); 
