
function save_msfile(filename,pc,species,genelist,threeoff)
fid = fopen(filename,'w');

if (nargin<5)
  threeoff = true;
end

fprintf(fid,'## created on %s by save_msfile.m\n',date());
fprintf(fid,'# SPECIES: %s\n',species);
fprintf(fid,'# NUMBER OF CELLS: %d\n',pc.nuclear_count);
fprintf(fid,'#cell_id,x,y,z,u,v');

for t = 1:6
  for i = 1:length(genelist)
    geneid = sprintf('%s__%d',genelist{i},t);
    if (threeoff)
      geneid3 = sprintf('%s__%d',genelist{i},t+3);
    else
      geneid3 = sprintf('%s__%d',genelist{i},t);
    end
    cind = strmatch(geneid3,pc.column,'exact');
    if ~isempty(cind)
      colind(i,t) =cind;
      bad(i,t) = false;
      fprintf(fid,',%s',geneid);
    else
      %error(sprintf('unable to find %s gene in atlas',geneid));
      sprintf('WARNING: unable to find %s gene in atlas',geneid3)
      colind(i,t) = 1;
      bad(i,t) = true;
%      fprintf(fid,',%s',geneid);
    end
  end;
end;
fprintf(fid,'\n');

X = pc.X{4};
X(:,1) = X(:,1)-min(X(:,1));
X = X/max(X(:,1));

C(:,1) = X(:,1);
C(:,2) = mod(atan2(X(:,2),X(:,3)),2*pi)/(2*pi);

E = pc.data(:,colind(:));
find(bad)
%E(:,bad(:))=0;;
E= E(:,~bad(:));

mv = max(E,[],1);
E = E*diag(1./(mv+(mv==0)));


for i = 1:pc.nuclear_count
    fprintf(fid,'%d,%.6f,%.6f,%.6f,',i,X(i,1),X(i,2),X(i,3));
    fprintf(fid,'%.6f,%.6f,%.6f,',C(i,1),C(i,2));
    fprintf(fid,'%.6f,',E(i,1:end-1));
    fprintf(fid,'%.6f\n',E(i,end));
end
fclose(fid);
