%
% return the nuclear coordinates after applying the transformation
%
% charless fowlkes (c) 2007
%

function [X,N] = transform(pc)

if isfield(pc,'translate')  & isfield(pc,'rotate1') & isfield(pc,'rotate2') & isfield(pc,'scale') & isfield(pc,'eggtranslate') 
  X = [pc.X ones(size(pc.X,1),1)]*pc.translate'*pc.rotate1'*pc.rotate2'*pc.scale'*pc.eggtranslate'*standardrot';
  X = X(:,1:3);

  N = [pc.N ones(size(pc.X,1),1)]*pc.rotate1'*pc.rotate2'*pc.scale'*standardrot';  
  N = N(:,1:3);
  N = N ./ repmat(sum(N.^2,2).^0.5,1,3);  %just in case of non-isotropic scaling
else %default scaling proceedure
  fprintf('performing default scaling\n');
  X = pc.X;
  N = pc.N;
  len = max(X(:,1))-min(X(:,1));
  X = X ./ len;
  X(:,1) = X(:,1)-min(X(:,1));
end;


