
%
% generate a table showing reduction in variation
%

C =  load('/home/datasets/bio/dpse-2008-01-31/coarse/atlas_data_coarse.mat');
F =  load('/home/datasets/bio/dpse-2008-01-31/atlas_data.mat');

fid = fopen('reduction_table.txt','w');
G = nan*zeros(numgenes,9)
for i = 1:numgenes
  fprintf(fid,'%s ',gene_names{i});
  for cht = 4:9
    if (ct(i,cht,1)>2)
      nb = mean(C.Estd(:,i,cht,1));
      na = mean(F.Estd(:,i,cht,1));
      if (na-nb > 0)
        %fprintf(fid,' & \\cellcolor[gray]{0.7}%3.3f & \\cellcolor[gray]{0.7}%3.3f ',nb,na)
        fprintf(fid,' & \\cellcolor[gray]{0.7}%3.1f',100*(na-nb) / nb);
      else
        %fprintf(fid,' & %3.3f & %3.3f ',nb,na)
        fprintf(fid,' & %3.1f',100*(na-nb) / nb);
      end
      G(i,cht) = (na-nb)/nb;
    else
      fprintf(fid,' & ');
    end
  end;
  fprintf(fid,'\\\\ \n');
end
fprintf(fid,'\\hline \n ave');
for cht = 4:9
  fprintf(fid,'& %3.2f',100*nanmean(G(:,cht)));
end;
fprintf(fid,'\\\\ \n');
fclose(fid)



