
%
% find a warping from src -> target that minimizes the tps energy
% apply that warping to ambient
%
% this uses a proper 3D tps spline with m = 3 which is more stable than m = 2;
%
% charless fowlkes, (c) 2007
%

function warped = warp3D(src,target,ambient,lambda)

  ns = size(src,1);
  na = size(ambient,1);
  dnull = 10; %dimenion of null space

  K=dist2(src,src).^(3/2); %greens function for m=3,d=3
  P=[ones(ns,1), src(:,1), src(:,2), src(:,3), src(:,1).*src(:,1), src(:,1).*src(:,2), src(:,1).*src(:,3), src(:,2).*src(:,2), src(:,2).*src(:,3), src(:,3).*src(:,3)];
  L=[K  P
     P' zeros(dnull,dnull)];
  V=[target' zeros(3,dnull)];
  L(1:ns,1:ns) = L(1:ns,1:ns) + lambda*eye(ns,ns);
  c=inv(L)*V';

  K = dist2(src,ambient).^(3/2); 
  P=[ones(na,1), ambient(:,1), ambient(:,2), ambient(:,3), ambient(:,1).*ambient(:,1), ambient(:,1).*ambient(:,2), ambient(:,1).*ambient(:,3), ambient(:,2).*ambient(:,2), ambient(:,2).*ambient(:,3), ambient(:,3).*ambient(:,3)];
  waX = c(end-dnull+1:end,1)'*P';
  wrbfX = c(1:end-dnull,1)'*K; 
  wX = waX + wrbfX;
  waY = c(end-dnull+1:end,2)'*P';
  wrbfY = c(1:end-dnull,2)'*K; 
  wY = waY + wrbfY;
  waZ = c(end-dnull+1:end,3)'*P';
  wrbfZ = c(1:end-dnull,3)'*K; 
  wZ = waZ + wrbfZ;
  warped = [wX' wY' wZ'];


